## tcc 0.9.23

=== Makefile ===
--- 
+++ 
@@ -20,12 +20,36 @@
 
 DISAS=objdump -d
 INSTALL=install
-PROGS=tcc$(EXESUF) c67-tcc$(EXESUF) arm-tcc$(EXESUF)
+
+ifdef CONFIG_WIN32
+PROGS=tcc$(EXESUF)
+ifdef CONFIG_CROSS
+PROGS+=c67-tcc$(EXESUF) arm-tcc$(EXESUF)
+endif
+PROGS+=tiny_impdef$(EXESUF)
+else
+ifeq ($(ARCH),i386)
+PROGS=tcc$(EXESUF)
+ifdef CONFIG_CROSS
+PROGS+=arm-tcc$(EXESUF)
+endif
+endif
+ifeq ($(ARCH),arm)
+PROGS=tcc$(EXESUF)
+ifdef CONFIG_CROSS
+PROGS+=i386-tcc$(EXESUF)
+endif
+endif
+ifdef CONFIG_CROSS
+PROGS+=c67-tcc$(EXESUF) i386-win32-tcc$(EXESUF)
+endif
+endif
+
 # run local version of tcc with local libraries and includes
 TCC=./tcc -B. -I.
 
 all: $(PROGS) \
-     libtcc1$(LIBSUF) $(BCHECK_O) tcc-doc.html tcc.1 libtcc$(LIBSUF) \
+     libtcc1.a $(BCHECK_O) tcc-doc.html tcc.1 libtcc.a \
      libtcc_test$(EXESUF)
 
 Makefile: config.mak
@@ -111,25 +135,55 @@
 ex3: ex3.c
 	$(CC) $(CFLAGS) -o $@ $<
 
-# Native Tiny C Compiler
-
-tcc_g$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h Makefile
+# Host Tiny C Compiler
+ifdef CONFIG_WIN32
+tcc$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h tccpe.c
+	$(CC) $(CFLAGS) -DTCC_TARGET_PE -o $@ $< $(LIBS)
+else
+ifeq ($(ARCH),i386)
+tcc$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h
 	$(CC) $(CFLAGS) -o $@ $< $(LIBS)
-
-tcc$(EXESUF): tcc_g$(EXESUF) Makefile
-	$(STRIP) -o $@ $<
-
-c67-tcc$(EXESUF): tcc.c c67-gen.c tccelf.c tccasm.c tcctok.h libtcc.h tcccoff.c Makefile
+endif
+ifeq ($(ARCH),arm)
+tcc$(EXESUF): tcc.c arm-gen.c tccelf.c tccasm.c tcctok.h libtcc.h
+	$(CC) $(CFLAGS) -DTCC_TARGET_ARM -o $@ $< $(LIBS)
+endif
+endif
+
+# Cross Tiny C Compilers
+i386-tcc$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h
+	$(CC) $(CFLAGS) -o $@ $< $(LIBS)
+
+c67-tcc$(EXESUF): tcc.c c67-gen.c tccelf.c tccasm.c tcctok.h libtcc.h tcccoff.c
 	$(CC) $(CFLAGS) -DTCC_TARGET_C67 -o $@ $< $(LIBS)
 
-arm-tcc$(EXESUF): tcc.c arm-gen.c tccelf.c tccasm.c tcctok.h libtcc.h Makefile
+arm-tcc$(EXESUF): tcc.c arm-gen.c tccelf.c tccasm.c tcctok.h libtcc.h
 	$(CC) $(CFLAGS) -DTCC_TARGET_ARM -o $@ $< $(LIBS)
 
+i386-win32-tcc$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h tccpe.c
+	$(CC) $(CFLAGS) -DTCC_TARGET_PE -o $@ $< $(LIBS)
+
+# windows utilities
+tiny_impdef$(EXESUF): tiny_impdef.c
+	$(CC) $(CFLAGS) -o $@ $< -lkernel32
+
 # TinyCC runtime libraries
-libtcc1.o: libtcc1.c
-	$(CC) -O2 -Wall -c -o $@ $<
-
-libtcc1$(LIBSUF): libtcc1.o
+ifdef CONFIG_WIN32
+# for windows, we must use TCC because we generate ELF objects
+LIBTCC1_OBJS=$(addprefix win32/lib/, crt1.o wincrt1.o dllcrt1.o dllmain.o chkstk.o) libtcc1.o
+LIBTCC1_CC=./tcc.exe -Bwin32
+else
+LIBTCC1_OBJS=libtcc1.o
+LIBTCC1_CC=$(CC)
+endif
+
+%.o: %.c
+	$(LIBTCC1_CC) -O2 -Wall -c -o $@ $<
+
+%.o: %.S
+	$(LIBTCC1_CC) -c -o $@ $<
+
+libtcc1.a: $(LIBTCC1_OBJS)
 	$(AR) rcs $@ $^
 
 bcheck.o: bcheck.c
@@ -137,26 +191,36 @@
 
 install: tcc_install libinstall
 
-tcc_install: $(PROGS) tcc.1 libtcc1$(LIBSUF) $(BCHECK_O) tcc-doc.html tcc.1
+tcc_install: $(PROGS) tcc.1 libtcc1.a $(BCHECK_O) tcc-doc.html tcc.1
 	mkdir -p "$(bindir)"
 	$(INSTALL) -s -m755 $(PROGS) "$(bindir)"
 ifndef CONFIG_WIN32
 	mkdir -p "$(mandir)/man1"
 	$(INSTALL) tcc.1 "$(mandir)/man1"
 endif
-	mkdir -p "$(libdir)/tcc"
-	mkdir -p "$(libdir)/tcc/include"
-	$(INSTALL) -m644 libtcc1$(LIBSUF) $(BCHECK_O) "$(libdir)/tcc"
+	mkdir -p "$(tccdir)"
+	mkdir -p "$(tccdir)/include"
+ifdef CONFIG_WIN32
+	mkdir -p "$(tccdir)/lib"
+	$(INSTALL) -m644 libtcc1.a win32/lib/*.def "$(tccdir)/lib"
+	cp -r win32/include/. "$(tccdir)/include"
+	cp -r win32/examples/. "$(tccdir)/examples"
+else
+	$(INSTALL) -m644 libtcc1.a $(BCHECK_O) "$(tccdir)"
 	$(INSTALL) -m644 stdarg.h stddef.h stdbool.h float.h varargs.h \
-                   tcclib.h "$(libdir)/tcc/include"
+                   tcclib.h "$(tccdir)/include"
+endif
 	mkdir -p "$(docdir)"
 	$(INSTALL) -m644 tcc-doc.html "$(docdir)"
+ifdef CONFIG_WIN32
+	$(INSTALL) -m644 win32/readme.txt "$(docdir)"
+endif
 
 clean:
-	rm -f *~ *.o tcc tcc1 tcct tcc_g tcctest.ref *.bin *.i ex2 \
+	rm -f *~ *.o *.a tcc tcc1 tcct tcc_g tcctest.ref *.bin *.i ex2 \
            core gmon.out test.out test.ref a.out tcc_p \
-           *.exe tcc-doc.html tcc.pod tcc.1 libtcc$(LIBSUF) libtcc_test \
-           tcctest[1234] test[1234].out c67-tcc arm-tcc
+           *.exe *.lib tcc.pod libtcc_test \
+           tcctest[1234] test[1234].out $(PROGS) win32/lib/*.o
 
 distclean: clean
 	rm -f config.h config.mak config.texi
@@ -166,20 +230,20 @@
 	$(CC) $(CFLAGS_P) -o $@ $< $(LIBS_P)
 
 # libtcc generation and example
-libinstall: libtcc$(LIBSUF) 
+libinstall: libtcc.a 
 	mkdir -p "$(libdir)"
-	$(INSTALL) -m644 libtcc$(LIBSUF) "$(libdir)"
+	$(INSTALL) -m644 libtcc.a "$(libdir)"
 	mkdir -p "$(includedir)"
 	$(INSTALL) -m644 libtcc.h "$(includedir)"
 
 libtcc.o: tcc.c i386-gen.c Makefile
 	$(CC) $(CFLAGS) -DLIBTCC -c -o $@ $<
 
-libtcc$(LIBSUF): libtcc.o 
+libtcc.a: libtcc.o 
 	$(AR) rcs $@ $^
 
-libtcc_test$(EXESUF): libtcc_test.c libtcc$(LIBSUF)
-	$(CC) $(CFLAGS) -o $@ $< libtcc$(LIBSUF) $(LIBS)
+libtcc_test$(EXESUF): libtcc_test.c libtcc.a
+	$(CC) $(CFLAGS) -o $@ $< libtcc.a $(LIBS)
 
 libtest: libtcc_test
 	./libtcc_test
@@ -224,25 +288,11 @@
 	./texi2pod.pl $< tcc.pod
 	pod2man --section=1 --center=" " --release=" " tcc.pod > $@
 
-FILES= Makefile Makefile.uClibc configure VERSION \
-       README TODO COPYING \
-       Changelog tcc-doc.texi tcc-doc.html \
-       tcc.1 \
-       tcc.c tccelf.c tcctok.h tccasm.c i386-asm.c i386-asm.h \
-       tcccoff.c coff.h \
-       i386-gen.c c67-gen.c arm-gen.c \
-       bcheck.c libtcc1.c \
-       elf.h stab.h stab.def \
-       stddef.h stdarg.h stdbool.h float.h varargs.h \
-       tcclib.h libtcc.h libtcc_test.c \
-       ex1.c ex2.c ex3.c ex4.c ex5.c \
-       tcctest.c boundtest.c gcctestsuite.sh texi2pod.pl
-
-FILE=tcc-$(VERSION)
-
+FILE=tcc-$(shell cat VERSION)
+
+# tar release (use 'make -k tar' on a checkouted tree)
 tar:
 	rm -rf /tmp/$(FILE)
-	mkdir -p /tmp/$(FILE)
-	cp -P $(FILES) /tmp/$(FILE)
-	( cd /tmp ; tar zcvf ~/$(FILE).tar.gz $(FILE) )
+	cp -r . /tmp/$(FILE)
+	( cd /tmp ; tar zcvf ~/$(FILE).tar.gz $(FILE) --exclude CVS )
 	rm -rf /tmp/$(FILE)
