=== debian/changelog ===
tcc (0.9.25-6) unstable; urgency=low

  * Reactivate support for armel arch.
  * Attempt to solve test suite failure on armel.
  * Register documentation with doc-base.
  * Fix the license of win32/tools/tiny_libmaker.c with author's agreement.
  * Convert package to multiarch.
  * debian/patches:
    + Stricter test about declaration of static function without file scope in
      local block to not error out in wrong situations (regression fix).
    + Add function and variable assembly labels.
  * debian/compat:
    + Bump debhelper compatibility from 7 to 8 (no changes needed).
  * debian/copyright:
    + Update and convert to DEP5 candidate format.
    + Update address of FSF.
    + Remove duplicate notices and give redistribution license.
  * debian/control:
    + Bump Standards-Version to 3.9.2 (no changes needed).
    + Improve synopsis wording for tcc.
  * Remove useless debian/tcc.dirs file

 -- Thomas Preud'homme <robotux@celest.fr>  Mon, 18 Oct 2010 15:58:01 +0200

tcc (0.9.25-5) unstable; urgency=low

  * Drop support for armel arch.

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 05 Sep 2010 23:15:47 +0200

tcc (0.9.25-4) unstable; urgency=low

  * Fix bashims in configure and gcctestsuite.sh.
  * Add support for indirect functions as externals.
  * Bump Standard-Version from 3.8.4 to 3.9.1 (no changes needed).
  * debian/control:
    - Improve package description for libtcc-dev.

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 10 Aug 2010 00:10:30 +0200

tcc (0.9.25-3) unstable; urgency=low

  * Change Vcs fields to reference Alioth.
  * Don't load libtcc1.a if not available (fix a FTBFS on armel).
  * Link alias symbols together. (Closes: #452876)
  * Support C99 Variable-Length Arrays. (Closes: #439135)

 -- Thomas Preud'homme <robotux@celest.fr>  Sat, 01 May 2010 23:44:46 +0200

tcc (0.9.25-2) unstable; urgency=low

  * Make tcc build on armv5tel, armv6j and armv7a architectures.
  * Clean patches submitted upstream following upstream advice.
  * Also clean 438097_configure_allow_nostrip.diff patch.
  * Convert patches to DEP3 patch format.

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 20 Apr 2010 22:44:37 +0200

tcc (0.9.25-1) unstable; urgency=low

  * New upstream release (Closes: #549100, LP: #500296).
    - Supports amd64 architecture.
  * Fix Hurd FTBFS (Closes: #532503).
  * Improve tcc handling of ld scripts: libs in GROUP command are
    searched repeatedly, as required.
  * Add support for kfreebsd-amd64.
  * Cherry-pick 55cb217 from upstream to fix incorrect elf output on
    FreeBSD kernels.
  * Make the package compile on armel (Closes: #506517).
  * x86_64_alloca.diff: Add alloca on x86-64, from upstream commits
    8ea8305 and dca2b15, to fix a test failure.
  * 528902_texi_direntry.diff: Add @dircategory and @direntry
    (Closes: #528902).
  * Complain for static fct declared without file scope
    (Closes: #170105).
  * Install the libtcc library in the new libtcc-dev package
    (Closes: #234245).
  * Remove unnecessary patches.
    - 322913_fix_casts_from_fp_to_bool.diff (already fixed in 0.9.24)
    - 474883_fix_segmentation_fault_when_compiling.diff
    - tcc-doc_texi_formatting.diff
  * Rewrite 419203_fix_sizeof_parse_error.diff patch.
  * Rebase patch on tcc version 0.9.25.
  * Add debian/watch file.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Add DESTDIR support in configure script.
  * Move info file creation from debian/rules to upstream Makefile.
  * Use a dh based debian/rule Makefile.
  * Bump debhelper compatibility from 4 to 7 (no changes needed).
  * Bump Standard-Version from 3.8.0 to 3.8.4 (no changes needed).
  * Fill Vcs-Browser and Vcs-Git fields.
  * Correctly support DEB_BUILD_OPTIONS.
  * Don't rebuild the package if it was already built before.

 -- Thomas Preud'homme <robotux@celest.fr>  Sat, 17 Apr 2010 20:41:12 +0200

tcc (0.9.24-1) unstable; urgency=high

  [ Aurélien GÉRÔME ]
  * Change my email address in the Maintainer field.
  * Bump Standards-Version to 3.8.0.
  * Remove no longer used XS-Vcs-Git and XS-Vcs-Browser fields.
  * Add the DM-Upload-Allowed field for Arthur.

  [ Thomas Preud'homme ]
  * New Upstream Version
    - tcc now supports typename as structure field name (closes: #278698)
    - A long long value used as a test expression ignores the
      upper 32 bits at runtime (closes: #304082)
  * Remove unecessary patches:
    - 352202_fix_int_overflow.diff
    - 283066_add_va_copy_define.diff (already disabled)
    - 430209_fix_bound_check_error.diff
  * Clean all patches (no fuzz or offset problem anymore)
  * Add patch from Bradley Smith to allow compilation with gcc 4.3
    (closes: #474883)
  * Add tcc-doc_texi_formatting.diff to correct formatting of tcc-doc.texi

 -- Thomas Preud'homme <robotux@celest.fr>  Mon, 16 Jun 2008 03:31:38 +0200

tcc (0.9.24~cvs20070502-2) unstable; urgency=low

  * 430209_fix_bound_check_error.diff: Add. (Closes: #430209)
    - Thanks to Thomas Preud'homme.
  * 438097_configure_allow_nostrip.diff: Add. (Closes: #438097)
  * Add myself to Uploaders, update debian/copyright accordingly.
  * debian/control: Use the new Homepage field.
  * Port on hurd-i386:
    - patches/series/hurd.diff: Add.
    - debian/control: Update Architecture list.

 -- Arthur Loiret <arthur.loiret@gmail.com>  Fri, 12 Oct 2007 04:31:48 +0200

tcc (0.9.24~cvs20070502-1) unstable; urgency=low

  [ Aurélien GÉRÔME ]
  * New maintainer and co-maintainer. (Closes: #420643)
  * Add the XS-Vcs-Git and XS-Vcs-Browser fields to debian/control.
  * Update homepage with the tiny URL in debian/control.
  * Remove unused ${misc:Depends} from debian/control.
  * Short description in debian/control is not a sentence, so start
    by a lowercase.
  * Remove unused debhelper tools from debian/rules.
  * Run test suite in debian/rules.
  * Remove .pc/ directory after build in the clean target of
    debian/rules.
  * Update debian/copyright.
  * TinyCC is no longer maintained upstream: use the latest CVS which

